﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.8
@EndOfDesignText@
Sub Class_Globals
	Private nativeMe As JavaObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	nativeMe = Me
End Sub

Public Sub genchecksum
	Dim Entropy As String = "1010110111011000110010010010111001001011001001010110001011100001"
	Dim checksum As String = nativeMe.RunMethod("genchecksum", Array(Entropy))
	Log ("checksum expected : 00 ")
	Log("checksum generated : " & checksum)
	
End Sub



#if java
import java.security.MessageDigest;
import java.nio.charset.StandardCharsets;
import java.math.BigInteger;

    public static String genchecksum(String mEntropy) throws Exception {
        String entropy = mEntropy;

        // 1. Create checksum
        int size = entropy.length() / 32; // Number of bits to take from hash of entropy (1 bit checksum for every 32 bits entropy)
       
	    BA.Log("size: " + size);
	   
        MessageDigest digest = MessageDigest.getInstance("SHA-256");
        byte[] sha256 = digest.digest(new BigInteger(entropy, 2).toByteArray()); // Hash of entropy (in raw binary)

        BA.Log("byte: " + sha256);

        String binarySha256 = new BigInteger(1, sha256).toString(2);
        // Ensure leading 0's are not lost
        while (binarySha256.length() < sha256.length * 8) {
            binarySha256 = "0" + binarySha256;
        }
        String checksum = binarySha256.substring(0, size); // Get desired number of bits
		return checksum;
    }

#End If